# Generated by Django 2.2 on 2019-08-09 13:19

from django.db import migrations, models
import django.db.models.deletion
from arkindex_common.ml_tool import MLToolType


def create_data_source(apps, schema_editor):
    DataSource = apps.get_model('documents', 'DataSource')
    Entity = apps.get_model('documents', 'Entity')

    if not Entity.objects.exists():
        # Prevent creating the default source on empty databases
        return

    data_source, _ = DataSource.objects.get_or_create(
        type=MLToolType.NER,
        slug="manual",
        internal=False
    )
    Entity.objects.all().update(source=data_source.id)


def delete_data_source(apps, schema_editor):
    DataSource = apps.get_model('documents', 'DataSource')
    Entity = apps.get_model('documents', 'Entity')
    Entity.objects.all().update(source=None)
    DataSource.objects.get(
        type=MLToolType.NER,
        slug="manual",
        internal=False
    ).delete()


class Migration(migrations.Migration):

    dependencies = [
        ('documents', '0014_entity_source_nullable'),
    ]

    operations = [
        migrations.RunPython(create_data_source, delete_data_source),
        migrations.AlterField(
            model_name='entity',
            name='source',
            field=models.ForeignKey(
                on_delete=django.db.models.deletion.CASCADE,
                related_name='entities',
                to='documents.DataSource'
            ),
        ),
    ]
