# Generated by Django 2.2 on 2019-09-05 13:49

from django.db import migrations, models
from django.db.models import F
import django.db.models.deletion
from arkindex.documents.models import ElementType


def change_page_to_element(apps, schema_editor):
    Classification = apps.get_model('documents', 'Classification')
    Classification.objects.update(element_id=F('page_id'))


def change_element_to_page(apps, schema_editor):
    Classification = apps.get_model('documents', 'Classification')
    Classification.objects.filter(element__type=ElementType.Page).update(page_id=F('element_id'))
    Classification.objects.exclude(element__type=ElementType.Page).delete()


class Migration(migrations.Migration):

    dependencies = [
        ('documents', '0015_entity_source'),
    ]

    operations = [
        migrations.AddField(
            model_name='classification',
            name='element',
            field=models.ForeignKey(
                on_delete=django.db.models.deletion.CASCADE,
                related_name='classifications',
                to='documents.Element', null=True
            ),
        ),
        migrations.RunPython(change_page_to_element, migrations.RunPython.noop),
        migrations.AlterField(
            model_name='classification',
            name='element',
            field=models.ForeignKey(
                on_delete=django.db.models.deletion.CASCADE,
                related_name='classifications',
                to='documents.Element'
            ),
        ),
        migrations.AlterUniqueTogether(
            name='classification',
            unique_together={('element', 'source', 'ml_class')},
        ),
        # To rollback
        migrations.AlterField(
            model_name='classification',
            name='page',
            field=models.ForeignKey(
                on_delete=django.db.models.deletion.CASCADE,
                related_name='classifications',
                to='documents.Page',
                null=True
            )
        ),
        migrations.RunPython(migrations.RunPython.noop, change_element_to_page),
        migrations.RemoveField(
            model_name='classification',
            name='page',
        ),
    ]
