from unittest import TestCase
from arkindex.project.tools import elasticsearch_escape


class TestTools(TestCase):

    def test_elasticsearch_escape(self):
        self.assertEqual(elasticsearch_escape('abcdef'), 'abcdef')
        self.assertEqual(elasticsearch_escape('aaaaa+b'), 'aaaaa\\\\+b')
        self.assertEqual(elasticsearch_escape('\\'), '\\\\')
        self.assertEqual(elasticsearch_escape('[]'), '\\\\[\\\\]')
        self.assertEqual(elasticsearch_escape(' \" '), ' \\\\\\" ')
        self.assertEqual(elasticsearch_escape('&|'), '&|')
        self.assertEqual(elasticsearch_escape('&&||'), '\\\\&&\\\\||')
        self.assertEqual(elasticsearch_escape('a<a>a'), 'aaa')
