#!/bin/sh
DB_HOST=${DB_HOST:-localhost}
DB_PORT=${DB_PORT:-9100}
DB_NAME=${DB_NAME:-arkindex_dev}
DB_USER=${DB_USER:-devuser}
DB_PASSWORD=${DB_PASSWORD:-devdata}
RO_USER=${RO_USER:-rouser}
RO_PASSWORD=${RO_PASSWORD:-ropassword}

# Create the read-only user if it does not exist
export PGPASSWORD="$DB_PASSWORD"
psql -h $DB_HOST -U $DB_USER -p $DB_PORT -tc "SELECT 1 FROM pg_user WHERE usename = '$RO_USER'" postgres | grep -q 1 || (
	psql -h $DB_HOST -U $DB_USER -p $DB_PORT -c "CREATE ROLE $RO_USER LOGIN PASSWORD '$RO_PASSWORD'; GRANT CONNECT ON DATABASE $DB_NAME TO $RO_USER" postgres
	psql -h $DB_HOST -U $DB_USER -p $DB_PORT -c "GRANT USAGE ON SCHEMA public TO $RO_USER; GRANT SELECT ON ALL TABLES IN SCHEMA public TO $RO_USER; GRANT SELECT ON ALL SEQUENCES IN SCHEMA public TO $RO_USER; ALTER DEFAULT PRIVILEGES IN SCHEMA public GRANT SELECT ON TABLES TO $RO_USER; ALTER DEFAULT PRIVILEGES IN SCHEMA public GRANT SELECT ON SEQUENCES TO $RO_USER" $DB_NAME
)

# Override database credentials
export PGPASSWORD=
export DB_USER="$RO_USER"
export DB_PASSWORD="$RO_PASSWORD"
manage.py "$@"
